package
{
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	import flash.utils.ByteArray;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{	
		public static var canvas:FlxSprite;
		public var canvaspixels:ByteArray;
		public var canvaspixelsghost:ByteArray;
		
		public static var nhood:Vector.<Boolean>;
		
		public static const leftmargin:int=26;
		
		public static const vmargin1:int=0;
		public static const vmargin2:int=87;
		public static const vmargin3:int=188;
		
		
		[Embed(source="data/r1.png")] public static var r1:Class;
		[Embed(source="data/r2.png")] public static var r2:Class;
		[Embed(source="data/picker.png")] public static var ImgPicker:Class;
		
		
		public var sizebuttons:Vector.<FlxButton>;
		public var brushbuttons:Vector.<FlxButton>;
		public var pickertarget:FlxSprite;
		public var picker:FlxSprite;
		public var selectedcol:int;//24 BIT!!!
		
		public function randAutomata():void
		{
			this.regenBrush();
		}
		
		override public function create():void
		{
			AutomataManager.Create(0xffff0000);
			sizebuttons = new Vector.<FlxButton>;
			brushbuttons = new Vector.<FlxButton>;
			
			picker = new FlxSprite(14,0,ImgPicker);
			this.add(picker);
			
			if (canvas==null)
			{
				canvas = new FlxSprite(leftmargin,0);
				canvas.createGraphic(FlxG.width-leftmargin,FlxG.height,0xffffffff,true);
				for (i=0;i<canvas.width;i++)
				{
					for (var j:int=0;j<canvas.height;j++)
					{
						//canvas._pixels.setPixel32(i,j,Math.random()<0.5?0xff000000:0xffffffff);
					}
				}
				canvas.resetHelpers();
				canvaspixels = canvas._pixels.getPixels(canvas._pixels.rect);				
				canvaspixelsghost = canvas._pixels.getPixels(canvas._pixels.rect);				
			}
			nhood = new Vector.<Boolean>;
			for (i=0;i<9;i++)
			{
				nhood.push(false);
			}
			canvasrect = new Rectangle(0,0,canvas.width,canvas.height);
			
			this.add(canvas);
			
			
			for (var i:int=0;i<42;i++)
			{
				var s:FlxSprite = new FlxSprite(0,0);
				s.createGraphic(14,14,0xff000000,true);
				s._pixels.fillRect(new Rectangle(1,1,12,12),0xffffffff);
				s._pixels.fillRect(new Rectangle(1+6-(i+1)/7,1+6-(i+1)/7,2*(i+1)/7,2*(i+1)/7),0xff000000);
				
				
				s.resetHelpers();
				
				
				var sup:FlxSprite = new FlxSprite(0,0);
				sup.createGraphic(14,14,0xffff0000,true);
				sup._pixels.fillRect(new Rectangle(1,1,12,12),0xffffffff);
				
				sup._pixels.fillRect(new Rectangle(1+6-(i+1)/7,1+6-(i+1)/7,2*(i+1)/7,2*(i+1)/7),0xff000000);
							
				sup.resetHelpers();
				
				var b:FlxButton = new FlxButton(0,vmargin1+14*i,Selector.Make(onClickSize,i));
				b.loadGraphic(s,sup);
				this.add(b);
				sizebuttons.push(b);
			}
			
			//t=0;		
			
			pickertarget = new FlxSprite(picker.x-1+Math.random()*picker.width,picker.y-1+Math.random()*picker.height);
			pickertarget.createGraphic(3,3,0xff000000,true);
			pickertarget._pixels.setPixel32(1,1,0x00000000);
			this.add(pickertarget);
			
			
			randAutomata();
			//this.onClickBrush(6);
			this.onClickSize(10);
			
			pickColor();
		}
			
		public var lastx:int=-1;
		public var lasty:int=-1;
		//public var t:Number;
		
		public function pickColor():void
		{
			selectedcol = this.picker._pixels.getPixel(pickertarget.x+1-picker.x,pickertarget.y+1-picker.y);
			regenBrush();
		}

		override public function update():void
		{		
			//t+=FlxG.elapsed;
			
			if (FlxG.mouse.x>GameState.leftmargin)
			{
				if ( (FlxG.mouse.pressed() && (lastx!=FlxG.mouse.x || lasty!=FlxG.mouse.y)) 
					||
					FlxG.mouse.justPressed()
				)
				{
					paint(FlxG.mouse.x-leftmargin,FlxG.mouse.y);
				}
			}
			
			if (FlxG.mouse.justPressed() && this.picker.overlapsPoint(FlxG.mouse.x,FlxG.mouse.y))
			{
				this.pickertarget.x=FlxG.mouse.x-1;
				this.pickertarget.y=FlxG.mouse.y-1;
				pickColor();
			}
		
			
			lastx=FlxG.mouse.x;
			lasty=FlxG.mouse.y;
			
			super.update();
		}
		
		public function paint(px:int,py:int):void
		{
			var x1:int=Math.max(px-(mySize+1),0);
			var x2:int=Math.min(px+(mySize+1),canvas.width);
			var y1:int=Math.max(py-(mySize+1),0);
			var y2:int=Math.min(py+(mySize+1),canvas.height);
			
			canvaspixels.position=0;
			canvaspixelsghost.position=0;
			canvaspixelsghost.writeBytes(canvaspixels, 0, canvaspixels.length);
			
			for (var i:int=x1;i<x2;i++)
			{
				for (var j:int=y1;j<y2;j++)
				{
					processPixel(i,j);
				}
			}
			canvaspixels.position=0;
			canvas._pixels.setPixels(canvasrect,canvaspixels);
			GameState.canvas.resetHelpers();
			
		}
		
		public static var mySize:int=2;
		private var canvasrect:Rectangle;
		
		public function getPixel(i:int,j:int):int // returns value between 0 and 7 inclusive
		{
			if (i<0 || i>=canvasrect.width || j<0 || j>=canvasrect.height)
					return 1;
			canvaspixelsghost.position=0;
			
			var v:int=0;
			
			if (canvaspixelsghost[4*(i+canvasrect.width*j)+1+0]==0)
				v+=1;
			if (canvaspixelsghost[4*(i+canvasrect.width*j)+1+1]==0)
				v+=2;
			if (canvaspixelsghost[4*(i+canvasrect.width*j)+1+2]==0)
				v+=4;
			
			return v;
			
		}//as an optimization, could add padding around the canvas sprite that would always just have 1s
		
		public function processPixel(i:int,j:int):void
		{
			//var n:uint = 1*getPixel(i,j-1) + 8*getPixel(i-1,j) + 8*8*getPixel(i,j)+8*8*8*getPixel(i+1,j)+8*8*8*8*getPixel(i,j+1);
			//trace(n);
			canvaspixels.position=4*(i+canvasrect.width*j); 			
			canvaspixels.writeUnsignedInt(AutomataManager.CurrentAutomata.tick(i,j));
			//canvaspixels[i+canvas.width*j]=0xff000000;
//			canvas._pixels.setPixel32(i,j,0xff000000);
			//get information about pixels in the vicinity
		}
		
		public function onClickSize(n:int):void
		{
			for (var i:int=0;i<42;i++)
			{
				sizebuttons[i].on=i==n;
			}
			mySize=n;
		}
		
		public static var myBrush:int=0;
		

		
		
		private function RGBToHex(r:uint, g:uint, b:uint):uint{
			var hex:uint = (r << 16 | g << 8 | b);
			return hex;
		}
		
		private function HexToRGB(hex:uint):Array{
			var rgb:Array = [];
			
			var r:uint = hex >> 16 & 0xFF;
			var g:uint = hex >> 8 & 0xFF;
			var b:uint = hex & 0xFF;
			
			rgb.push(r, g, b);
			return rgb;
		}
		
		
		
		 /**
		  * Converts an RGB color value to HSL. Conversion formula
		  * adapted from http://en.wikipedia.org/wiki/HSL_color_space.
		  * Assumes r, g, and b are contained in the set [0, 255] and
		  * returns h, s, and l in the set [0, 1].
		  *
		  * @param   Number  r       The red color value
		  * @param   Number  g       The green color value
		  * @param   Number  b       The blue color value
		  * @return  Array           The HSL representation
		  */
		 private function rgbToHsl(r:Number, g:Number, b:Number):Array
		 {
		     r /= 255, g /= 255, b /= 255;
		     var max:Number = Math.max(r, g, b), min:Number = Math.min(r, g, b);
		     var h:Number, s:Number, l:Number = (max + min) / 2;
		 
		     if(max == min){
		         h = s = 0; // achromatic
		     }else{
		         var d:Number = max - min;
		         s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
		         switch(max){
		             case r: h = (g - b) / d + (g < b ? 6 : 0); break;
		             case g: h = (b - r) / d + 2; break;
		             case b: h = (r - g) / d + 4; break;
		         }
		         h /= 6;
		     }
		 
		     return [h, s, l];
		 }
		 
		 /**
		  * Converts an HSL color value to RGB. Conversion formula
		  * adapted from http://en.wikipedia.org/wiki/HSL_color_space.
		  * Assumes h, s, and l are contained in the set [0, 1] and
		  * returns r, g, and b in the set [0, 255].
		  *
		  * @param   Number  h       The hue
		  * @param   Number  s       The saturation
		  * @param   Number  l       The lightness
		  * @return  Array           The RGB representation
		  */
		 private function hslToRgb(h:Number, s:Number, l:Number):Array
		 {
		     var r:Number, g:Number, b:Number;
		 
		     if(s == 0){
		         r = g = b = l; // achromatic
		     }else{
		         function hue2rgb(p:Number, q:Number, t:Number):Number{
		             if(t < 0) t += 1;
		             if(t > 1) t -= 1;
		             if(t < 1/6) return p + (q - p) * 6 * t;
		             if(t < 1/2) return q;
		             if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
		             return p;
		         }
		 
		         var q:Number = l < 0.5 ? l * (1 + s) : l + s - l * s;
		         var p:Number = 2 * l - q;
		         r = hue2rgb(p, q, h + 1/3);
		         g = hue2rgb(p, q, h);
		         b = hue2rgb(p, q, h - 1/3);
		     }
		 
		     return [r * 255, g * 255, b * 255];
		 }
		 
		
		
		
		

		
		
		public function regenBrush():void
		{
			var hs_rgb:Array = this.HexToRGB(this.selectedcol);
			var v:Number=hs_rgb[0]/255.0;//gives value between 0 and 1
			

			AutomataManager.Create(v);
		}
	}
	
}

class Selector
{
	private var _onClick:Function;
	private var _n:int;
	
	public static function Make(f:Function,n:int):Function
	{
		var s:Selector = new Selector(f,n);
		return s.onClick;
	}
	
	public function Selector(f:Function,n:int)
	{
		_onClick=f;
		_n=n;
	}
	
	public function onClick():void
	{
		_onClick(_n);	
	}		
}